<template>
  <div ref="memberFormContainer" class="memberFormContainer invisible">
    <div class="formLimiter">
      <input ref="formFirstName" class="stretch">
      <input ref="formLastName" class="stretch">
      <button ref="memberSubmitButton" @click="handleFormSubmit">Add new member</button>
      <button ref="memberCancelButton" @click="closeForm">Cancel</button>
    </div>
  </div>
</template>

<script>
export default {
  name: 'AddMemberForm',
  props: ['index'],
  methods: {
    handleFormSubmit() {
      const that = this;
      const fieldFirstName = this.$refs.formFirstName;
      const fieldLastName = this.$refs.formLastName;
      const submitButton = this.$refs.memberSubmitButton;

      let validFieldSumCheck = 0;
      if (fieldFirstName.value.trim() !== '') {
        validFieldSumCheck += 1;
      }
      if (fieldLastName.value.trim() !== '') {
        validFieldSumCheck += 1;
      }
      if (validFieldSumCheck >= 2) {
        const payload = {};

        payload.teamID = this.index;
        payload.firstName = fieldFirstName.value;
        payload.lastName = fieldLastName.value;

        fieldFirstName.style.background = 'rgb(0, 255, 0)';
        fieldLastName.style.background = 'rgb(0, 255, 0)';
        submitButton.disabled = true;
        that.$store.dispatch('saveNewMember', payload);
        setTimeout(() => {
          that.closeForm(submitButton);
        }, 100);
      } else {
        fieldFirstName.style.background = 'rgb(255, 0, 0)';
        fieldLastName.style.background = 'rgb(255, 0, 0)';
      }
    },
    closeForm(submitButton) {
      const formContainer = this.$refs.memberFormContainer;
      if (formContainer.classList.contains('visible')) {
        formContainer.classList.remove('visible');
        formContainer.classList.add('invisible');
      }
      this.clearForm(submitButton);
    },
    clearForm(submitButton) {
      const memberFirstName = this.$refs.formFirstName;
      const memberLastName = this.$refs.formLastName;
      const localSubmitButton = submitButton;
      memberFirstName.value = '';
      memberLastName.value = '';
      memberFirstName.style.background = 'rgb(255, 255, 255)';
      memberLastName.style.background = 'rgb(255, 255, 255)';
      localSubmitButton.disabled = false;
    },
  },
};
</script>

<style scoped>
  .stretch {
    width: 100%;
  }
  .visible {
    display: block;
  }
  .invisible {
    display: none;
  }
  .memberFormContainer {
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    height: 100vh;
    background: rgba(0, 0, 0, 0.4);
    z-index: 10;
  }
  .formLimiter {
    position: absolute;
    top: calc(50% - 100px);
    left: calc(50% - 100px);
    width: 200px;
    height: 200px;
  }
</style>
